Index: /BAORadio/libindi/libindi/libs/lilxml.c
===================================================================
--- /BAORadio/libindi/libindi/libs/lilxml.c	(revision 641)
+++ /BAORadio/libindi/libindi/libs/lilxml.c	(revision 642)
@@ -15,5 +15,5 @@
     You should have received a copy of the GNU Lesser General Public
     License along with this library; if not, write to the Free Software
-    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
+    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 #endif
@@ -27,4 +27,5 @@
  */
 
+#include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
@@ -41,5 +42,5 @@
 #define	MINMEM	64			/* starting string length */
 
-static int oneXMLchar (LilXML *lp, int c, char errmsg[]);
+static int oneXMLchar (LilXML *lp, int c, char ynot[]);
 static void initParser(LilXML *lp);
 static void pushXMLEle(LilXML *lp);
@@ -111,5 +112,5 @@
 static char entities[] = "&<>'\"";
 
-/* default memory managers, override with indi_xmlMalloc() */
+/* default memory managers, override with lilxmlMalloc() */
 static void *(*mymalloc)(size_t size) = malloc;
 static void *(*myrealloc)(void *ptr, size_t size) = realloc;
@@ -120,11 +121,11 @@
  */
 void
-indi_xmlMalloc (void *(*newmalloc)(size_t size),
-	   void *(*newrealloc)(void *ptr, size_t size),
-	   void (*newfree)(void *ptr))
-{
-	mymalloc = newmalloc;
-	myrealloc = newrealloc;
-	myfree = newfree;
+lilxmlMalloc (void *(*newmalloc)(size_t size),
+           void *(*newrealloc)(void *ptr, size_t size),
+           void (*newfree)(void *ptr))
+{
+        mymalloc = newmalloc;
+        myrealloc = newrealloc;
+        myfree = newfree;
 }
 
@@ -133,8 +134,8 @@
 newLilXML ()
 {
-	LilXML *lp = (LilXML *) moremem (NULL, sizeof(LilXML));
-	memset (lp, 0, sizeof(LilXML));
-	initParser(lp);
-	return (lp);
+        LilXML *lp = (LilXML *) moremem (NULL, sizeof(LilXML));
+        memset (lp, 0, sizeof(LilXML));
+        initParser(lp);
+        return (lp);
 }
 
@@ -143,7 +144,7 @@
 delLilXML (LilXML *lp)
 {
-	delXMLEle (lp->ce);
-	freeString (&lp->endtag);
-	(*myfree) (lp);
+        delXMLEle (lp->ce);
+        freeString (&lp->endtag);
+        (*myfree) (lp);
 }
 
@@ -152,114 +153,149 @@
 delXMLEle (XMLEle *ep)
 {
-	int i;
-
-	/* benign if NULL */
-	if (!ep)
-	    return;
-
-	/* delete all parts of ep */
-	freeString (&ep->tag);
-	freeString (&ep->pcdata);
-	if (ep->at) {
-	    for (i = 0; i < ep->nat; i++)
-		freeAtt (ep->at[i]);
-	    (*myfree) (ep->at);
-	}
-	if (ep->el) {
-	    for (i = 0; i < ep->nel; i++) {
-		/* forget parent so deleting doesn't modify _this_ el[] */
-		ep->el[i]->pe = NULL;
-
-		delXMLEle (ep->el[i]);
-	    }
-	    (*myfree) (ep->el);
-	}
-
-	/* remove from parent's list if known */
-	if (ep->pe) {
-	    XMLEle *pe = ep->pe;
-	    for (i = 0; i < pe->nel; i++) {
-		if (pe->el[i] == ep) {
-		    memmove (&pe->el[i], &pe->el[i+1],
-					      (--pe->nel-i)*sizeof(XMLEle*));
-		    break;
-		}
-	    }
-	}
-
-	/* delete ep itself */
-	(*myfree) (ep);
+        int i;
+
+        /* benign if NULL */
+        if (!ep)
+            return;
+
+        /* delete all parts of ep */
+        freeString (&ep->tag);
+        freeString (&ep->pcdata);
+        if (ep->at) {
+            for (i = 0; i < ep->nat; i++)
+                freeAtt (ep->at[i]);
+            (*myfree) (ep->at);
+        }
+        if (ep->el) {
+            for (i = 0; i < ep->nel; i++) {
+                /* forget parent so deleting doesn't modify _this_ el[] */
+                ep->el[i]->pe = NULL;
+
+                delXMLEle (ep->el[i]);
+            }
+            (*myfree) (ep->el);
+        }
+
+        /* remove from parent's list if known */
+        if (ep->pe) {
+            XMLEle *pe = ep->pe;
+            for (i = 0; i < pe->nel; i++) {
+                if (pe->el[i] == ep) {
+                    memmove (&pe->el[i], &pe->el[i+1],
+                                              (--pe->nel-i)*sizeof(XMLEle*));
+                    break;
+                }
+            }
+        }
+
+        /* delete ep itself */
+        (*myfree) (ep);
 }
 
 /* process one more character of an XML file.
  * when find closure with outter element return root of complete tree.
- * when find error return NULL with reason in errmsg[].
- * when need more return NULL with errmsg[0] = '\0'.
+ * when find error return NULL with reason in ynot[].
+ * when need more return NULL with ynot[0] = '\0'.
  * N.B. it is up to the caller to delete any tree returned with delXMLEle().
  */
 XMLEle *
-readXMLEle (LilXML *lp, int newc, char errmsg[])
-{
-	XMLEle *root;
-	int s;
-
-	/* start optimistic */
-	errmsg[0] = '\0';
-
-	/* EOF? */
-	if (newc == 0) {
-	    sprintf (errmsg, "Line %d: early XML EOF", lp->ln);
-	    initParser(lp);
-	    return (NULL);
-	}
-
-	/* new line? */
-	if (newc == '\n')
-	    lp->ln++;
-
-	/* skip comments and declarations. requires 1 char history */
-	if (!lp->skipping && lp->lastc == '<' && (newc == '?' || newc == '!')) {
-	    lp->skipping = 1;
-	    lp->lastc = newc;
-	    return (NULL);
-	}
-	if (lp->skipping) {
-	    if (newc == '>')
-		lp->skipping = 0;
-	    lp->lastc = newc;
-	    return (NULL);
-	}
-	if (newc == '<') {
-	    lp->lastc = '<';
-	    return (NULL);
-	}
-
-	/* do a pending '<' first then newc */
-	if (lp->lastc == '<') {
-	    if (oneXMLchar (lp, '<', errmsg) < 0) {
-		initParser(lp);
-		return (NULL);
-	    }
-	    /* N.B. we assume '<' will never result in closure */
-	}
-
-	/* process newc (at last!) */
-	s = oneXMLchar (lp, newc, errmsg);
-	if (s == 0) {
-	    lp->lastc = newc;
-	    return (NULL);
-	}
-	if (s < 0) {
-	    initParser(lp);
-	    return (NULL);
-	}
-
-	/* Ok! return ce and we start over.
-	 * N.B. up to caller to call delXMLEle with what we return.
-	 */
-	root = lp->ce;
-	lp->ce = NULL;
-	initParser(lp);
-	return (root);
+readXMLEle (LilXML *lp, int newc, char ynot[])
+{
+        XMLEle *root;
+        int s;
+
+        /* start optimistic */
+        ynot[0] = '\0';
+
+        /* EOF? */
+        if (newc == 0) {
+            sprintf (ynot, "Line %d: early XML EOF", lp->ln);
+            initParser(lp);
+            return (NULL);
+        }
+
+        /* new line? */
+        if (newc == '\n')
+            lp->ln++;
+
+        /* skip comments and declarations. requires 1 char history */
+        if (!lp->skipping && lp->lastc == '<' && (newc == '?' || newc == '!')) {
+            lp->skipping = 1;
+            lp->lastc = newc;
+            return (NULL);
+        }
+        if (lp->skipping) {
+            if (newc == '>')
+                lp->skipping = 0;
+            lp->lastc = newc;
+            return (NULL);
+        }
+        if (newc == '<') {
+            lp->lastc = '<';
+            return (NULL);
+        }
+
+        /* do a pending '<' first then newc */
+        if (lp->lastc == '<') {
+            if (oneXMLchar (lp, '<', ynot) < 0) {
+                initParser(lp);
+                return (NULL);
+            }
+            /* N.B. we assume '<' will never result in closure */
+        }
+
+        /* process newc (at last!) */
+        s = oneXMLchar (lp, newc, ynot);
+        if (s == 0) {
+            lp->lastc = newc;
+            return (NULL);
+        }
+        if (s < 0) {
+            initParser(lp);
+            return (NULL);
+        }
+
+        /* Ok! return ce and we start over.
+         * N.B. up to caller to call delXMLEle with what we return.
+         */
+        root = lp->ce;
+        lp->ce = NULL;
+        initParser(lp);
+        return (root);
+}
+
+/* parse the given XML string.
+ * return XMLEle* else NULL with reason why in ynot[]
+ */
+XMLEle *
+parseXML (char buf[], char ynot[])
+{
+        LilXML *lp = newLilXML();
+        XMLEle *root;
+
+        do {
+            root = readXMLEle (lp, *buf++, ynot);
+        } while (!root && !ynot[0]);
+
+        delLilXML (lp);
+
+        return (root);
+}
+
+/* return a deep copy of the given XMLEle *
+ */
+XMLEle *
+cloneXMLEle (XMLEle *ep)
+{
+        char *buf;
+        char ynot[1024];
+        XMLEle *newep;
+
+        buf = (*mymalloc) (sprlXMLEle (ep, 0) + 1);
+        sprXMLEle (buf, ep, 0);
+        newep = parseXML (buf, ynot);
+        (*myfree) (buf);
+
+        return (newep);
 }
 
@@ -270,10 +306,10 @@
 findXMLAtt (XMLEle *ep, const char *name)
 {
-	int i;
-
-	for (i = 0; i < ep->nat; i++)
-	    if (!strcmp (ep->at[i]->name.s, name))
-		return (ep->at[i]);
-	return (NULL);
+        int i;
+
+        for (i = 0; i < ep->nat; i++)
+            if (!strcmp (ep->at[i]->name.s, name))
+                return (ep->at[i]);
+        return (NULL);
 }
 
@@ -284,13 +320,13 @@
 findXMLEle (XMLEle *ep, const char *tag)
 {
-	int tl = strlen (tag);
-	int i;
-
-	for (i = 0; i < ep->nel; i++) {
-	    String *sp = &ep->el[i]->tag;
-	    if (sp->sl == tl && !strcmp (sp->s, tag))
-		return (ep->el[i]);
-	}
-	return (NULL);
+        int tl = strlen (tag);
+        int i;
+
+        for (i = 0; i < ep->nel; i++) {
+            String *sp = &ep->el[i]->tag;
+            if (sp->sl == tl && !strcmp (sp->s, tag))
+                return (ep->el[i]);
+        }
+        return (NULL);
 }
 
@@ -302,13 +338,13 @@
 nextXMLEle (XMLEle *ep, int init)
 {
-	int eit;
-	
-	if (init)
-	    ep->eit = 0;
-
-	eit = ep->eit++;
-	if (eit < 0 || eit >= ep->nel)
-	    return (NULL);
-	return (ep->el[eit]);
+        int eit;
+
+        if (init)
+            ep->eit = 0;
+
+        eit = ep->eit++;
+        if (eit < 0 || eit >= ep->nel)
+            return (NULL);
+        return (ep->el[eit]);
 }
 
@@ -320,13 +356,13 @@
 nextXMLAtt (XMLEle *ep, int init)
 {
-	int ait;
-
-	if (init)
-	    ep->ait = 0;
-
-	ait = ep->ait++;
-	if (ait < 0 || ait >= ep->nat)
-	    return (NULL);
-	return (ep->at[ait]);
+        int ait;
+
+        if (init)
+            ep->ait = 0;
+
+        ait = ep->ait++;
+        if (ait < 0 || ait >= ep->nat)
+            return (NULL);
+        return (ep->at[ait]);
 }
 
@@ -335,5 +371,5 @@
 parentXMLEle (XMLEle *ep)
 {
-	return (ep->pe);
+        return (ep->pe);
 }
 
@@ -342,5 +378,5 @@
 parentXMLAtt (XMLAtt *ap)
 {
-	return (ap->ce);
+        return (ap->ce);
 }
 
@@ -351,5 +387,5 @@
 tagXMLEle (XMLEle *ep)
 {
-	return (ep->tag.s);
+        return (ep->tag.s);
 }
 
@@ -358,12 +394,12 @@
 pcdataXMLEle (XMLEle *ep)
 {
-	return (ep->pcdata.s);
+        return (ep->pcdata.s);
 }
 
 /* return the number of characters in the pcdata portion of the given element */
-int 
+int
 pcdatalenXMLEle (XMLEle *ep)
 {
-	return (ep->pcdata.sl);
+        return (ep->pcdata.sl);
 }
 
@@ -372,5 +408,5 @@
 nameXMLAtt (XMLAtt *ap)
 {
-	return (ap->name.s);
+        return (ap->name.s);
 }
 
@@ -379,5 +415,5 @@
 valuXMLAtt (XMLAtt *ap)
 {
-	return (ap->valu.s);
+        return (ap->valu.s);
 }
 
@@ -386,5 +422,5 @@
 nXMLEle (XMLEle *ep)
 {
-	return (ep->nel);
+        return (ep->nel);
 }
 
@@ -393,5 +429,5 @@
 nXMLAtt (XMLEle *ep)
 {
-	return (ep->nat);
+        return (ep->nat);
 }
 
@@ -403,23 +439,23 @@
 findXMLAttValu (XMLEle *ep, const char *name)
 {
-	XMLAtt *a = findXMLAtt (ep, name);
-	return (a ? a->valu.s : "");
+        XMLAtt *a = findXMLAtt (ep, name);
+        return (a ? a->valu.s : "");
 }
 
 /* handy wrapper to read one xml file.
- * return root element else NULL with report in errmsg[]
+ * return root element else NULL with report in ynot[]
  */
 XMLEle *
-readXMLFile (FILE *fp, LilXML *lp, char errmsg[])
-{
-	int c;
-
-	while ((c = fgetc(fp)) != EOF) {
-	    XMLEle *root = readXMLEle (lp, c, errmsg);
-	    if (root || errmsg[0])
-		return (root);
-	}
-
-	return (NULL);
+readXMLFile (FILE *fp, LilXML *lp, char ynot[])
+{
+        int c;
+
+        while ((c = fgetc(fp)) != EOF) {
+            XMLEle *root = readXMLEle (lp, c, ynot);
+            if (root || ynot[0])
+                return (root);
+        }
+
+        return (NULL);
 }
 
@@ -430,7 +466,17 @@
 addXMLEle (XMLEle *parent, const char *tag)
 {
-	XMLEle *ep = growEle (parent);
-	appendString (&ep->tag, tag);
-	return (ep);
+        XMLEle *ep = growEle (parent);
+        appendString (&ep->tag, tag);
+        return (ep);
+}
+
+/* append an existing element to the given element.
+ * N.B. be mindful of when these are deleted, this is not a deep copy.
+ */
+void
+appXMLEle (XMLEle *ep, XMLEle *newep)
+{
+        ep->el = (XMLEle **) moremem (ep->el, (ep->nel+1)*sizeof(XMLEle *));
+        ep->el[ep->nel++] = newep;
 }
 
@@ -439,7 +485,7 @@
 editXMLEle (XMLEle *ep, const char *pcdata)
 {
-	freeString (&ep->pcdata);
-	appendString (&ep->pcdata, pcdata);
-	ep->pcdata_hasent = (strpbrk (pcdata, entities) != NULL);
+        freeString (&ep->pcdata);
+        appendString (&ep->pcdata, pcdata);
+        ep->pcdata_hasent = (strpbrk (pcdata, entities) != NULL);
 }
 
@@ -448,8 +494,8 @@
 addXMLAtt (XMLEle *ep, const char *name, const char *valu)
 {
-	XMLAtt *ap = growAtt (ep);
-	appendString (&ap->name, name);
-	appendString (&ap->valu, valu);
-	return (ap);
+        XMLAtt *ap = growAtt (ep);
+        appendString (&ap->name, name);
+        appendString (&ap->valu, valu);
+        return (ap);
 }
 
@@ -458,13 +504,13 @@
 rmXMLAtt (XMLEle *ep, const char *name)
 {
-	int i;
-
-	for (i = 0; i < ep->nat; i++) {
-	    if (strcmp (ep->at[i]->name.s, name) == 0) {
-		freeAtt (ep->at[i]);
-		memmove (&ep->at[i],&ep->at[i+1],(--ep->nat-i)*sizeof(XMLAtt*));
-		return;
-	    }
-	}
+        int i;
+
+        for (i = 0; i < ep->nat; i++) {
+            if (strcmp (ep->at[i]->name.s, name) == 0) {
+                freeAtt (ep->at[i]);
+                memmove (&ep->at[i],&ep->at[i+1],(--ep->nat-i)*sizeof(XMLAtt*));
+                return;
+            }
+        }
 }
 
@@ -473,6 +519,6 @@
 editXMLAtt (XMLAtt *ap, const char *str)
 {
-	freeString (&ap->valu);
-	appendString (&ap->valu, str);
+        freeString (&ap->valu);
+        appendString (&ap->valu, str);
 }
 
@@ -484,30 +530,30 @@
 prXMLEle (FILE *fp, XMLEle *ep, int level)
 {
-	int indent = level*PRINDENT;
-	int i;
-
-	fprintf (fp, "%*s<%s", indent, "", ep->tag.s);
-	for (i = 0; i < ep->nat; i++)
-	    fprintf (fp, " %s=\"%s\"", ep->at[i]->name.s,
-						entityXML(ep->at[i]->valu.s));
-	if (ep->nel > 0) {
-	    fprintf (fp, ">\n");
-	    for (i = 0; i < ep->nel; i++)
-		prXMLEle (fp, ep->el[i], level+1);
-	}
-	if (ep->pcdata.sl > 0) {
-	    if (ep->nel == 0)
-		fprintf (fp, ">\n");
-	    if (ep->pcdata_hasent)
-		fprintf (fp, "%s", entityXML(ep->pcdata.s));
-	    else
-		fprintf (fp, "%s", ep->pcdata.s);
-	    if (ep->pcdata.s[ep->pcdata.sl-1] != '\n')
-		fprintf (fp, "\n");
-	}
-	if (ep->nel > 0 || ep->pcdata.sl > 0)
-	    fprintf (fp, "%*s</%s>\n", indent, "", ep->tag.s);
-	else
-	    fprintf (fp, "/>\n");
+        int indent = level*PRINDENT;
+        int i;
+
+        fprintf (fp, "%*s<%s", indent, "", ep->tag.s);
+        for (i = 0; i < ep->nat; i++)
+            fprintf (fp, " %s=\"%s\"", ep->at[i]->name.s,
+                                                entityXML(ep->at[i]->valu.s));
+        if (ep->nel > 0) {
+            fprintf (fp, ">\n");
+            for (i = 0; i < ep->nel; i++)
+                prXMLEle (fp, ep->el[i], level+1);
+        }
+        if (ep->pcdata.sl > 0) {
+            if (ep->nel == 0)
+                fprintf (fp, ">\n");
+            if (ep->pcdata_hasent)
+                fprintf (fp, "%s", entityXML(ep->pcdata.s));
+            else
+                fprintf (fp, "%s", ep->pcdata.s);
+            if (ep->pcdata.s[ep->pcdata.sl-1] != '\n')
+                fprintf (fp, "\n");
+        }
+        if (ep->nel > 0 || ep->pcdata.sl > 0)
+            fprintf (fp, "%*s</%s>\n", indent, "", ep->tag.s);
+        else
+            fprintf (fp, "/>\n");
 }
 
@@ -520,35 +566,35 @@
 sprXMLEle (char *s, XMLEle *ep, int level)
 {
-	int indent = level*PRINDENT;
-	int sl = 0;
-	int i;
-
-	sl += sprintf (s+sl, "%*s<%s", indent, "", ep->tag.s);
-	for (i = 0; i < ep->nat; i++)
-	    sl += sprintf (s+sl, " %s=\"%s\"", ep->at[i]->name.s,
-						entityXML(ep->at[i]->valu.s));
-	if (ep->nel > 0) {
-	    sl += sprintf (s+sl, ">\n");
-	    for (i = 0; i < ep->nel; i++)
-		sl += sprXMLEle (s+sl, ep->el[i], level+1);
-	}
-	if (ep->pcdata.sl > 0) {
-	    if (ep->nel == 0)
-		sl += sprintf (s+sl, ">\n");
-	    if (ep->pcdata_hasent)
-		sl += sprintf (s+sl, "%s", entityXML(ep->pcdata.s));
-	    else {
-		strcpy (s+sl, ep->pcdata.s);
-		sl += ep->pcdata.sl;
-	    }
-	    if (ep->pcdata.s[ep->pcdata.sl-1] != '\n')
-		sl += sprintf (s+sl, "\n");
-	}
-	if (ep->nel > 0 || ep->pcdata.sl > 0)
-	    sl += sprintf (s+sl, "%*s</%s>\n", indent, "", ep->tag.s);
-	else
-	    sl += sprintf (s+sl, "/>\n");
-
-	return (sl);
+        int indent = level*PRINDENT;
+        int sl = 0;
+        int i;
+
+        sl += sprintf (s+sl, "%*s<%s", indent, "", ep->tag.s);
+        for (i = 0; i < ep->nat; i++)
+            sl += sprintf (s+sl, " %s=\"%s\"", ep->at[i]->name.s,
+                                                entityXML(ep->at[i]->valu.s));
+        if (ep->nel > 0) {
+            sl += sprintf (s+sl, ">\n");
+            for (i = 0; i < ep->nel; i++)
+                sl += sprXMLEle (s+sl, ep->el[i], level+1);
+        }
+        if (ep->pcdata.sl > 0) {
+            if (ep->nel == 0)
+                sl += sprintf (s+sl, ">\n");
+            if (ep->pcdata_hasent)
+                sl += sprintf (s+sl, "%s", entityXML(ep->pcdata.s));
+            else {
+                strcpy (s+sl, ep->pcdata.s);
+                sl += ep->pcdata.sl;
+            }
+            if (ep->pcdata.s[ep->pcdata.sl-1] != '\n')
+                sl += sprintf (s+sl, "\n");
+        }
+        if (ep->nel > 0 || ep->pcdata.sl > 0)
+            sl += sprintf (s+sl, "%*s</%s>\n", indent, "", ep->tag.s);
+        else
+            sl += sprintf (s+sl, "/>\n");
+
+        return (sl);
 }
 
@@ -560,33 +606,33 @@
 sprlXMLEle (XMLEle *ep, int level)
 {
-	int indent = level*PRINDENT;
-	int l = 0;
-	int i;
-
-	l += indent + 1 + ep->tag.sl;
-	for (i = 0; i < ep->nat; i++)
-	    l += ep->at[i]->name.sl + 4 + strlen(entityXML(ep->at[i]->valu.s));
-
-	if (ep->nel > 0) {
-	    l += 2;
-	    for (i = 0; i < ep->nel; i++)
-		l += sprlXMLEle (ep->el[i], level+1);
-	}
-	if (ep->pcdata.sl > 0) {
-	    if (ep->nel == 0)
-		l += 2;
-	    if (ep->pcdata_hasent)
-		l += strlen (entityXML(ep->pcdata.s));
-	    else
-		l += ep->pcdata.sl;
-	    if (ep->pcdata.s[ep->pcdata.sl-1] != '\n')
-		l += 1;
-	}
-	if (ep->nel > 0 || ep->pcdata.sl > 0)
-	    l += indent + 4 + ep->tag.sl;
-	else
-	    l += 3;
-
-	return (l);
+        int indent = level*PRINDENT;
+        int l = 0;
+        int i;
+
+        l += indent + 1 + ep->tag.sl;
+        for (i = 0; i < ep->nat; i++)
+            l += ep->at[i]->name.sl + 4 + strlen(entityXML(ep->at[i]->valu.s));
+
+        if (ep->nel > 0) {
+            l += 2;
+            for (i = 0; i < ep->nel; i++)
+                l += sprlXMLEle (ep->el[i], level+1);
+        }
+        if (ep->pcdata.sl > 0) {
+            if (ep->nel == 0)
+                l += 2;
+            if (ep->pcdata_hasent)
+                l += strlen (entityXML(ep->pcdata.s));
+            else
+                l += ep->pcdata.sl;
+            if (ep->pcdata.s[ep->pcdata.sl-1] != '\n')
+                l += 1;
+        }
+        if (ep->nel > 0 || ep->pcdata.sl > 0)
+            l += indent + 4 + ep->tag.sl;
+        else
+            l += 3;
+
+        return (l);
 }
 
@@ -598,56 +644,59 @@
 entityXML (char *s)
 {
-	static char *malbuf;
-	int nmalbuf = 0;
-	char *sret;
-	char *ep;
-
-	/* scan for each entity, if any */
-	for (sret = s; (ep = strpbrk (s, entities)) != NULL; s = ep+1) {
-
-	    /* found another entity, copy preceding to malloced buffer */
-	    int nnew = ep - s;			/* all but entity itself */
-	    sret = malbuf = moremem (malbuf, nmalbuf + nnew + 10);
-	    memcpy (malbuf+nmalbuf, s, nnew);
-	    nmalbuf += nnew;
-
-	    /* replace with entity encoding */
-	    switch (*ep) {
-	    case '&':
-		nmalbuf += sprintf (malbuf+nmalbuf, "&amp;");
-		break;
-	    case '<':
-		nmalbuf += sprintf (malbuf+nmalbuf, "&lt;");
-		break;
-	    case '>':
-		nmalbuf += sprintf (malbuf+nmalbuf, "&gt;");
-		break;
-	    case '\'':
-		nmalbuf += sprintf (malbuf+nmalbuf, "&apos;");
-		break;
-	    case '"':
-		nmalbuf += sprintf (malbuf+nmalbuf, "&quot;");
-		break;
-
-	    }
-
-	}
-
-	/* return s if no entities, else malloc cleaned-up copy */
-	if (sret == s) {
-	    /* using s, so free any malloced memory from last time */
-	    if (malbuf) {
-		free (malbuf);
-		malbuf = NULL;
-	    }
-	} else {
-	    /* put remaining part of s into malbuf */
-	    int nleft = strlen (s) + 1;		/* include \0 */
-	    sret = malbuf = moremem (malbuf, nmalbuf + nleft);
-	    memcpy (malbuf+nmalbuf, s, nleft);
-	}
-
-	return (sret);
-}
+        static char *malbuf;
+        int nmalbuf = 0;
+        char *sret;
+        char *ep;
+
+        /* scan for each entity, if any */
+        for (sret = s; (ep = strpbrk (s, entities)) != NULL; s = ep+1) {
+
+            /* found another entity, copy preceding to malloced buffer */
+            int nnew = ep - s;			/* all but entity itself */
+            sret = malbuf = moremem (malbuf, nmalbuf + nnew + 10);
+            memcpy (malbuf+nmalbuf, s, nnew);
+            nmalbuf += nnew;
+
+            /* replace with entity encoding */
+            switch (*ep) {
+            case '&':
+                nmalbuf += sprintf (malbuf+nmalbuf, "&amp;");
+                break;
+            case '<':
+                nmalbuf += sprintf (malbuf+nmalbuf, "&lt;");
+                break;
+            case '>':
+                nmalbuf += sprintf (malbuf+nmalbuf, "&gt;");
+                break;
+            case '\'':
+                nmalbuf += sprintf (malbuf+nmalbuf, "&apos;");
+                break;
+            case '"':
+                nmalbuf += sprintf (malbuf+nmalbuf, "&quot;");
+                break;
+
+            }
+
+        }
+
+        /* return s if no entities, else malloc cleaned-up copy */
+        if (sret == s) {
+            /* using s, so free any malloced memory from last time */
+            if (malbuf) {
+                free (malbuf);
+                malbuf = NULL;
+            }
+        } else {
+            /* put remaining part of s into malbuf */
+            int nleft = strlen (s) + 1;		/* include \0 */
+            sret = malbuf = moremem (malbuf, nmalbuf + nleft);
+            memcpy (malbuf+nmalbuf, s, nleft);
+        }
+
+        return (sret);
+}
+
+
+
 
 /* if ent is a recognized xml entity sequence, set *cp to char and return 1
@@ -657,24 +706,24 @@
 decodeEntity (char *ent, int *cp)
 {
-	static struct {
-	    const char *ent;
-	    char c;
-	} enttable[] = {
-	    {"&amp;",  '&'},
-	    {"&apos;", '\''},
-	    {"&lt;",   '<'},
-	    {"&gt;",   '>'},
-	    {"&quot;", '"'},
-	};
-	unsigned int i;
-
-	for (i = 0; i < sizeof(enttable)/sizeof(enttable[0]); i++) {
-	    if (strcmp (ent, enttable[i].ent) == 0) {
-		*cp = enttable[i].c;
-		return (1);
-	    }
-	}
-	
-	return (0);
+        static struct {
+            char *ent;
+            char c;
+        } enttable[] = {
+            {"&amp;",  '&'},
+            {"&apos;", '\''},
+            {"&lt;",   '<'},
+            {"&gt;",   '>'},
+            {"&quot;", '"'},
+        };
+        int i;
+
+        for (i = 0; i < sizeof(enttable)/sizeof(enttable[0]); i++) {
+            if (strcmp (ent, enttable[i].ent) == 0) {
+                *cp = enttable[i].c;
+                return (1);
+            }
+        }
+
+        return (0);
 }
 
